package de.fernunihagen.rtt.ui;

import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import org.eclipse.core.runtime.CoreException;

/**
 * Action adapter provider interface.
 * 
 * @author Osama El Hosami
 */
public interface IActionAdapterProvider {
	/**
	 * Retrieves the action provider identifier.
	 * 
	 * @return Identifier
	 */
	@Post("null != $return")
	String getID();

	/**
	 * Retrieves all available action adapters.
	 * 
	 * @return Action adapters
	 */
	@Post("null != $return")
	IActionAdapter[] get();

	/**
	 * Retrieves the action adapter with matching identifier.
	 * 
	 * @param id
	 *            Identifier
	 * 
	 * @return The action
	 * 
	 * @throws CoreException
	 *             <ul>
	 *             <li>If not found</li>
	 *             </ul>
	 */
	@Pre("null != id")
	@Post("null != $return")
	IActionAdapter get(String id) throws CoreException;
}
