package de.fernunihagen.rtt.ui.internal.jdt.launcher;

import org.contract4j5.contract.Contract;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

/**
 * Test subject content provider.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class TestSubjectContentProvider implements ITreeContentProvider {

	private static final Object[] NO_ELEMENTS = new Object[0];

	/**
	 * Creates a test subject content provider.
	 */
	public TestSubjectContentProvider() {
	}

	@Override
	public Object[] getChildren(final Object parentElement) {
		return ((AbstractTestSubject) parentElement).getChildren();
	}

	@Override
	public Object getParent(final Object element) {
		return ((AbstractTestSubject) element).getParent();
	}

	@Override
	public boolean hasChildren(final Object element) {
		return ((AbstractTestSubject) element).hasChildren();
	}

	@Override
	public Object[] getElements(final Object inputElement) {
		if (null != inputElement
				&& inputElement instanceof ToolTestConfiguration) {
			return ((ToolTestConfiguration) inputElement).getTestSubjectContainer();
		}
		return NO_ELEMENTS;
	}

	@Override
	public void dispose() {
	}

	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
	}

}
