package de.fernunihagen.rtt.ui.internal.jdt.launcher;

import static de.fernunihagen.rtt.internal.util.ClassUtil.getClassUtil;

import org.contract4j5.contract.Contract;

import org.eclipse.core.resources.IResource;

import org.eclipse.core.runtime.IAdaptable;

import org.eclipse.jface.viewers.ViewerCell;

import org.eclipse.swt.widgets.Control;

import de.fernunihagen.rtt.ui.internal.RTTCoreUIPlugin;

import de.fernunihagen.rtt.ui.internal.util.ViewerField;

/**
 * Test field location.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class ToolTestFieldLocation extends ViewerField {

	@Override
	public String getColumnHeaderText() {
		return "Location";
	}

	@Override
	public String getID() {
		return "location";
	}

	@Override
	public int getDefaultColumnWidth(final Control control) {
		return 4 * super.getDefaultColumnWidth(control);
	}

	private <T> T as(final IAdaptable adaptable, final Class<? extends T> clazz) {
		return getClassUtil().as(adaptable, clazz);
	}

	@Override
	public void update(final ViewerCell cell) {
		final IAdaptable element = (IAdaptable) cell.getElement();
		final IResource resource = as(element, IResource.class);
		final String location = resource.getProjectRelativePath()
				.removeLastSegments(1).toPortableString();

		cell.setImage(RTTCoreUIPlugin.createImage("eview16/package.gif"));
		cell.setText(location);
	}

}
