package de.fernunihagen.rtt.ui.internal.util;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.eclipse.jface.viewers.CellLabelProvider;
import org.eclipse.jface.viewers.ColumnViewer;
import org.eclipse.jface.viewers.ViewerCell;
import org.eclipse.jface.viewers.ViewerColumn;


/**
 * Test element column label provider.
 * 
 * @author Osama El Hosami
 */
@Contract
public class ViewerFieldLabelProvider extends CellLabelProvider {

	@Invar("null != $target")
	private final ViewerField _field;

	/**
	 * Creates a test element column label provider.
	 * 
	 * @param field
	 *            Field
	 */
	public ViewerFieldLabelProvider(final ViewerField field) {
		super();
		_field = field;
	}

	@Override
	public void update(final ViewerCell cell) {
		_field.update(cell);
	}

	@Override
	public void dispose(final ColumnViewer viewer, final ViewerColumn column) {
		_field.dispose(viewer, column);
		super.dispose();
	}

}
