package de.fernunihagen.rtt.ui.internal.view;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import org.eclipse.jface.viewers.ViewerCell;

import de.fernunihagen.rtt.framework.ITestElement;
import de.fernunihagen.rtt.ui.internal.util.ViewerField;

/**
 * Test element field class.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class TestElementFieldClass extends ViewerField {

	@Override
	@Post
	public String getColumnHeaderText() {
		return "Class";
	}

	@Override
	@Post
	public String getID() {
		return "class";
	}

	@Override
	@Pre
	public void update(final ViewerCell cell) {
		final ITestElement element = (ITestElement) cell.getElement();
		cell.setText(element.getClass().getSimpleName());
	}

}
