package de.fernunihagen.rtt.ui.internal.view;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;
import org.eclipse.jface.viewers.ViewerCell;

import de.fernunihagen.rtt.framework.ITestElement;
import de.fernunihagen.rtt.ui.internal.util.ViewerField;

/**
 * Test element field progress state.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class TestElementFieldProgressState extends ViewerField {

	@Override
	@Post
	public String getColumnHeaderText() {
		return "Progress State";
	}

	@Override
	@Post
	public String getID() {
		return "progressstate";
	}

	@Override
	@Pre
	public void update(final ViewerCell cell) {
		final ITestElement element = (ITestElement) cell.getElement();
		cell.setText(element.getProgressState(true).name());
	}

}
