package de.fernunihagen.rtt.ui.internal.view;

import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;
import org.eclipse.jface.viewers.ViewerCell;

import de.fernunihagen.rtt.framework.ITestElement;
import de.fernunihagen.rtt.ui.internal.util.ViewerField;

/**
 * Test element field time.
 * 
 * @author Osama El Hosami
 */
public final class TestElementFieldTime extends ViewerField {

	@Override
	@Post
	public String getColumnHeaderText() {
		return "Time";
	}

	@Override
	@Post
	public String getID() {
		return "time";
	}

	@Override
	@Pre
	public void update(final ViewerCell cell) {
		final ITestElement element = (ITestElement) cell.getElement();
		cell.setText(String.format("%.3fs", element.getElapsedTimeInSeconds()));
	}

}
