package de.fernunihagen.rtt;

import java.lang.annotation.Retention;
import java.lang.annotation.Target;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.ElementType;

/**
 * Test parameter annotation, used to bind annotated parameter to query
 * statement variable.
 * 
 * @author Osama El Hosami
 */
@Retention(value = RetentionPolicy.RUNTIME)
@Target(value = { ElementType.PARAMETER })
public @interface TestParam {
	/**
	 * Retrieves the variable name used to bind annotated parameter to query
	 * statement variable.
	 */
	String value();
}
