package de.fernunihagen.rtt.framework;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;

/**
 * Test application interface
 * 
 * @author Osama El Hosami
 */
@Contract
public interface ITestApplication {
	/**
	 * Application entry.
	 * 
	 * @param args
	 *            Command line arguments
	 * @param monitor
	 *            The progress monitor to use for reporting progress to the
	 *            user. It is the caller's responsibility to call done() on the
	 *            given monitor. Accepts <code>null</code>, indicating that no
	 *            progress should be reported and that the operation cannot be
	 *            canceled
	 * 
	 * @return Status
	 */
	@Pre("null != args")
	@Post("null != $return")
	IStatus run(String[] args, IProgressMonitor monitor);

	/**
	 * Disposes application resources.
	 */
	void dispose();
}
