package de.fernunihagen.rtt.framework;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

/**
 * Abstract test actor state object.
 * 
 * @author Osama El Hosami
 */
@Contract
public abstract class TestActorState implements ITestActorState {

	@Invar("null != $target")
	private final ITestActor _originator;

	/**
	 * Creates an abstract test actor state object.
	 * 
	 * @param originator
	 *            Test actor
	 */
	@Pre("null != originator")
	public TestActorState(final ITestActor originator) {
		_originator = originator;
	}

	@Override
	@Post
	public ITestActor getOriginator() {
		return _originator;
	}

}
