package de.fernunihagen.rtt.framework.model;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import de.fernunihagen.rtt.framework.ITestElementContainer;

/**
 * Structural test element container.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class StructuralTestElementContainer extends
		AbstractTestElementContainer {
	@Invar("null != $target")
	private final ITestElementContainer _parent;
	@Invar("null != $target")
	private final String _label;

	/**
	 * Creates structural test element container.
	 * 
	 * @param parent
	 *            Parent container
	 * @param initSize
	 *            Initial size
	 * @param label
	 *            Label
	 */
	@Pre("null != parent && 0 <= initSize && null != label")
	StructuralTestElementContainer(final ITestElementContainer parent,
			final int initSize, final String label) {
		super(initSize);
		_parent = parent;
		_label = label;

		parent.add(this);
	}

	@Override
	@Post
	public ITestElementContainer getParentContainer() {
		return _parent;
	}

	@Override
	@Post
	public String getLabel() {
		return _label;
	}
}
