package de.fernunihagen.rtt.framework.model;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import de.fernunihagen.rtt.framework.ITestContext;

/**
 * Test element container.
 * 
 * @author Osama El Hosami
 */
@Contract
public abstract class TestElementContainer extends AbstractTestElementContainer {

	@Invar("null != $target")
	private final ITestContext _context;
	@Invar("null != $target")
	private final String _label;

	/**
	 * Creates a test element container
	 * 
	 * @param context
	 *            Run context
	 * @param initSize
	 *            Initial size
	 * @param label
	 *            Label
	 */
	@Pre("null != context && initSize >= 0 && null != label")
	public TestElementContainer(final ITestContext context, final int initSize,
			final String label) {
		super(initSize);
		_context = context;
		_label = label;
	}

	@Override
	@Post
	public ITestContext getParentContainer() {
		return _context;
	}

	@Override
	@Post
	public String getLabel() {
		return _label;
	}
}
