package de.fernunihagen.rtt.framework.model;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import de.fernunihagen.rtt.framework.ITestContext;

/**
 * Test run stage element container.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class TestRunStageElementContainer extends TestElementContainer {

	@Invar("null != $target")
	private final RunStage _stage;

	/**
	 * Creates a test run stage element container.
	 * 
	 * @param context
	 *            Run context
	 * @param initSize
	 *            Initial size
	 * @param label
	 *            Label
	 * @param stage
	 *            Run stage
	 */
	@Pre("null != context && initSize >= 0 && null != label && null != stage")
	TestRunStageElementContainer(final ITestContext context,
			final int initSize, final String label, final RunStage stage) {
		super(context, initSize, label);
		_stage = stage;

		context.add(this);
	}

	@Override
	@Post
	public RunStage getStage() {
		return _stage;
	}

	@Override
	@Post("null != $return")
	public String toString() {
		final String message = String.format("[%s (/L %s) : %s]",
				getParentContainer(), getLabel(), getStage());
		return message;
	}
}
