package de.fernunihagen.rtt.framework.repository;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Pre;

/**
 * An objects that visits diffs in a diff tree.
 * 
 * @author Osama El Hosami
 */
@Contract
public interface IDiffVisitor {
	/**
	 * Visits the given diff.
	 * 
	 * @param diff
	 *            the diff being visited
	 * @return <code>true</code> if the diff's children should be visited;
	 *         <code>false</code> if they should be skipped.
	 */
	@Pre("null != diff")
	boolean visit(IDiff diff);
}
