package de.fernunihagen.rtt.framework.repository;

/**
 * A subscriber change listener is notified of changes to resources regarding
 * their subscriber synchronization state.
 * 
 * @see ISubscriber#addListener(ISubscriberChangeListener)
 * 
 * @author Osama El Hosami
 */
public interface ISubscriberChangeListener {
	/**
	 * Notifies this listener that some resources' subscriber properties have
	 * changed. The changes have already happened. For example, a resource's
	 * base revision may have changed. The resource tree may or may not be open
	 * for modification when this method is invoked.
	 * 
	 * @param delta
	 *            detailing the kinds of changes
	 */
	public void resourceChanged(IDiff delta);
}
