package de.fernunihagen.rtt.framework.repository.team;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Pre;

import org.eclipse.team.core.diff.IDiff;

import de.fernunihagen.rtt.framework.repository.IDiffVisitor;

/**
 * Team diff visitor adapter.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class TeamDiffVisitor implements
		org.eclipse.team.core.diff.IDiffVisitor {

	@Invar("null != $target")
	private final IDiffVisitor _adaptee;

	/**
	 * Creates a team visitor
	 * 
	 * @param visitor
	 *            Visitor
	 */
	@Pre("null != visitor")
	public TeamDiffVisitor(final IDiffVisitor visitor) {
		_adaptee = visitor;
	}

	@Override
	public boolean visit(final IDiff diff) {
		return _adaptee.visit(TeamDiff.local(diff));
	}

	@Override
	public int hashCode() {
		return _adaptee.hashCode();
	}

	@Override
	public String toString() {
		return _adaptee.toString();
	}

	@Override
	public boolean equals(final Object other) {
		if (other == this) {
			return true;
		}
		if (null == other) {
			return false;
		}
		return other.equals(_adaptee);
	}
}
