package de.fernunihagen.rtt.internal.filter;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Pre;

import org.eclipse.core.runtime.IAdaptable;

import de.fernunihagen.rtt.framework.IElementCollector;
import de.fernunihagen.rtt.framework.IElementFilter;

/**
 * Collector filter adapter.
 * 
 * @param <T>
 *            Model element type
 * 
 * @author Osama El Hosami
 */
@Contract
public final class CollectorFilterAdapter<T extends IAdaptable> implements
		IElementFilter<T> {
	@Invar("null != $target")
	private final IElementCollector<? extends IAdaptable> _collector;

	/**
	 * Creates a collector element filter adapter.
	 * 
	 * @param collector
	 *            Collector
	 */
	@Pre("null != collector")
	public CollectorFilterAdapter(
			final IElementCollector<? extends IAdaptable> collector) {
		_collector = collector;
	}

	@Override
	@Pre
	public boolean accept(final IAdaptable element) {
		return _collector.getMatches().contains(element);
	}
}
