package de.fernunihagen.rtt.internal.filter;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Pre;

import de.fernunihagen.rtt.framework.IElementFilter;

/**
 * Inverted element filter.
 * 
 * @author Osama El Hosami
 * 
 * @param <T>
 *            Model element type
 */
@Contract
public final class InvertedElementFilter<T> implements IElementFilter<T> {

	@Invar("null != $target")
	private final IElementFilter<T> _adaptee;

	/**
	 * Creates an inverted element filter.
	 * 
	 * @param filter
	 *            to adapt
	 */
	@Pre("null != filter")
	public InvertedElementFilter(final IElementFilter<T> filter) {
		_adaptee = filter;
	}

	@Override
	public boolean accept(final T element) {
		return !_adaptee.accept(element);
	}
}
