package de.fernunihagen.rtt.internal.jdt;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Pre;

import org.eclipse.jdt.junit.model.ITestElement;

/**
 * JUnit test run notification.
 * 
 * @author Osama El Hosami
 */
@Contract
public class JUnitTestRunNotification {
	/**
	 * Test element
	 */
	@Invar("null != $target")
	public final ITestElement testelement;
	/**
	 * Notification type
	 */
	@Invar("null != $target")
	public final Type type;

	/**
	 * Notification type
	 */
	public enum Type {
		SESSION_STARTED, SESSION_FINISHED, TESTCASE_STARTED, TESTCASE_FINISHED
	}

	/**
	 * Creates a test run notification
	 * 
	 * @param type
	 *            Notification type
	 * @param testelement
	 *            Test element
	 */
	@Pre("null != type && null != testelement")
	public JUnitTestRunNotification(final Type type,
			final ITestElement testelement) {
		this.testelement = testelement;
		this.type = type;
	}
}
