package de.fernunihagen.rtt.internal.jdt.oracle;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import de.fernunihagen.rtt.framework.ITestElementContainer;

import de.fernunihagen.rtt.framework.model.AbstractTestElementContainer;

import de.fernunihagen.rtt.internal.jdt.JUnitTestRun;

/**
 * JUnit test session element container.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class JUnitTestSessionElementContainer extends
		AbstractTestElementContainer {
	@Invar("null != $target")
	private final JUnitTestRun<?> _run;
	@Invar("null != $target")
	private final ITestElementContainer _parent;

	/**
	 * Creates JUnit test session element container.
	 * 
	 * @param parent
	 *            Parent container
	 * @param run
	 *            Test run
	 */
	@Pre("null != parent && null != run")
	public JUnitTestSessionElementContainer(final ITestElementContainer parent,
			final JUnitTestRun<?> run) {
		super();
		_run = run;
		_parent = parent;

		parent.add(this);
	}

	@Override
	@Post("null != $return")
	public String toString() {
		final String message = String.format("[%s (/R %s)]",
				getParentContainer(), getLabel());
		return message;
	}

	@Override
	@Post
	public ITestElementContainer getParentContainer() {
		return _parent;
	}

	@Override
	@Post
	public String getLabel() {
		return _run.toString();
	}
}
