package de.fernunihagen.rtt.internal.jdt.oracle;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import org.eclipse.jdt.junit.model.ITestSuiteElement;

import de.fernunihagen.rtt.framework.ITestElementContainer;
import de.fernunihagen.rtt.framework.model.AbstractTestElementContainer;

/**
 * JUnit test suite element container.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class JUnitTestSuiteElementContainer extends
		AbstractTestElementContainer {

	@Invar("null != $target")
	private final String _name;
	@Invar("null != $target")
	private final ITestElementContainer _parent;

	/**
	 * Creates JUnit test suite element container.
	 * 
	 * @param parent
	 *            Parent container
	 * @param suite
	 *            suite
	 */
	@Pre("null != parent && null != suite")
	public JUnitTestSuiteElementContainer(final ITestElementContainer parent,
			final ITestSuiteElement suite) {
		super();
		_parent = parent;
		_name = suite.getSuiteTypeName();

		parent.add(this);
	}

	@Override
	@Post
	public ITestElementContainer getParentContainer() {
		return _parent;
	}

	@Override
	@Post("null != $return")
	public String toString() {
		final String message = String.format("[%s (/S %s)]",
				getParentContainer(), getLabel());
		return message;
	}

	@Override
	@Post
	public String getLabel() {
		return _name;
	}
}
