package de.fernunihagen.rtt.internal.testadapter;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Post;
import org.eclipse.core.runtime.CoreException;

import de.fernunihagen.rtt.TestProcedureStep;

/**
 * Next test procedure step.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class NextTestProcedureStep extends TestProcedureStep {

	private static final class NextTestProcedureStepHolder {
		static final NextTestProcedureStep _DEFAULT = new NextTestProcedureStep();
	}

	private NextTestProcedureStep() {
	}

	/**
	 * Retrieves the shared instance.
	 * 
	 * @return The shared instance
	 */
	public static NextTestProcedureStep getInstance() {
		return NextTestProcedureStepHolder._DEFAULT;
	}

	@Override
	public void accept(final ITestProcedureStepVisitor visitor)
			throws CoreException {
		visitor.visit(this);
	}

	@Override
	@Post
	public FlowDecision getFlowDecision() {
		return FlowDecision.NEXT;
	}
}
