package de.fernunihagen.rtt.internal.testadapter;

import org.contract4j5.contract.Contract;
import org.eclipse.core.runtime.CoreException;

import de.fernunihagen.rtt.TestProcedureStep;

/**
 * Skip test procedure step.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class SkipTestProcedureStep extends TestProcedureStep {

	private static final class SkipTestProcedureStepHolder {
		static final SkipTestProcedureStep _DEFAULT = new SkipTestProcedureStep();
	}

	private SkipTestProcedureStep() {
	}

	/**
	 * Retrieves the shared instance.
	 * 
	 * @return The shared instance
	 */
	public static TestProcedureStep getInstance() {
		return SkipTestProcedureStepHolder._DEFAULT;
	}

	@Override
	public void accept(final ITestProcedureStepVisitor visitor)
			throws CoreException {
		visitor.visit(this);
	}

	@Override
	public FlowDecision getFlowDecision() {
		return FlowDecision.SKIP;
	}
}
