package de.fernunihagen.rtt.internal.util;

import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

/**
 * The condition representing false
 * 
 * @author Osama El Hosami
 */
public final class ConditionFalse extends Condition {

	/**
	 * Create the condition indicating state false.
	 */
	ConditionFalse() {
	}

	@Override
	@Pre()
	@Post()
	public Condition and(final Condition other) {
		return this;
	}

	@Override
	@Post()
	public Condition not() {
		return Condition.TRUE;
	}

	@Override
	@Pre()
	@Post()
	public Condition or(final Condition other) {
		return other;
	}

	@Override
	@Pre()
	@Post()
	public Condition xor(final Condition other) {
		return other;
	}

	@Override
	@Pre()
	public <R, X extends Throwable> R invoke(
			final IConditionalCommand<R, X> functor, final Object... args)
			throws X {
		return functor.invoke(this, args);
	}
}
