package de.fernunihagen.rtt.internal.util;

import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

/**
 * The condition representing true.
 * 
 * @author Osama El Hosami
 */
public final class ConditionTrue extends Condition {

	/**
	 * Create the condition indicating state true.
	 */
	ConditionTrue() {
	}

	@Override
	@Pre()
	@Post()
	public Condition and(final Condition other) {
		return other;
	}

	@Override
	@Post()
	public Condition not() {
		return Condition.FALSE;
	}

	@Override
	@Pre()
	@Post()
	public Condition or(final Condition other) {
		return this;
	}

	@Override
	@Pre()
	@Post()
	public Condition xor(final Condition other) {
		return other.not();
	}

	@Override
	@Pre()
	public <R, X extends Throwable> R invoke(
			final IConditionalCommand<R, X> command, final Object... args)
			throws X {
		return command.invoke(this, args);
	}
}
