package de.fernunihagen.rtt.internal.util;

import java.io.File;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Pre;

/**
 * File node.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class FileNode extends AbstractFileNode {

	/**
	 * Create a file node.
	 * 
	 * @param file
	 *            File handle
	 */
	@Pre("null != file")
	FileNode(final File file) {
		super(file);
	}

	@Override
	@Pre
	public void accept(final FileNodeVisitor visitor) {
		visitor.visit(this);
	}
}
