package de.fernunihagen.rtt.internal.util;

/**
 * Binary command interface - special case of a function object, with two
 * execution argument.
 * 
 * @param <F>
 *            Fist argument type
 * @param <S>
 *            Second argument type
 * @param <R>
 *            Result type
 * @param <X>
 *            Exception type
 * 
 * @author Osama El Hosami
 */
public interface IBinaryCommand<F, S, R, X extends Throwable> {
	/**
	 * Executes a binary command.
	 * 
	 * @param first
	 *            First command argument
	 * @param second
	 *            Second command argument
	 * 
	 * @return The command result
	 */
	R execute(F first, S second) throws X;
}
