package de.fernunihagen.rtt.internal.util;

/**
 * Generic command interface.
 * 
 * @param <R>
 *            Result type
 * @param <X>
 *            Exception type
 * 
 * @author Osama El Hosami
 */
public interface ICommand<R, X extends Throwable> {
	/**
	 * Executes the command.
	 * 
	 * @return The command result
	 */
	R execute() throws X;
}
