package de.fernunihagen.rtt.internal.util;

import java.lang.reflect.Method;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Pre;

/**
 * Method matcher interface, used to lookup a method by name.
 * 
 * @author Osama El Hosami
 */
@Contract
public interface IMethodMatcher {
	/**
	 * Looks up method with given name and signature.
	 * 
	 * @param clazz
	 *            Class
	 * @param paramTypes
	 *            Parameter argument types or null
	 * @param returnType
	 *            Return type or null
	 * @param methodName
	 *            Method name or null
	 * 
	 * @return Method instance or null
	 */
	@Pre("null != clazz")
	Method lookup(Class<?> clazz, Class<?>[] paramTypes, Class<?> returnType,
			String methodName);
}
