package de.fernunihagen.rtt.internal.util;

/**
 * Unary command interface - special case of function object, with one execution
 * argument.
 * 
 * @param <T>
 *            Argument type
 * @param <R>
 *            Result type
 * @param <X>
 *            Exception type
 * 
 * @author Osama El Hosami
 */
public interface IUnaryCommand<T, R, X extends Throwable> {
	/**
	 * Executes a unary command.
	 * 
	 * @param arg
	 *            The unary command argument
	 * 
	 * @return The command result
	 */
	R execute(T arg) throws X;
}
