package de.fernunihagen.rtt.internal.util;

import java.util.Comparator;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Pre;

/**
 * Inverts compare result of an adapted comparator.
 * 
 * @param <T>
 *            Compare type
 * 
 * @author Osama El Hosami
 */
@Contract
public final class InvertedComparator<T> implements Comparator<T> {
	@Invar("null != $target")
	private Comparator<T> _adaptee;

	/**
	 * Creates an inverted comparator.
	 * 
	 * @param comparator
	 *            to adapt
	 */
	@Pre("null != comparator")
	public InvertedComparator(final Comparator<T> comparator) {
		_adaptee = comparator;
	}

	@Override
	public int compare(T one, T other) {
		return _adaptee.compare(other, one);
	}
}
