package de.fernunihagen.rtt.internal.util;

import java.io.Serializable;

import java.util.Comparator;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import de.fernunihagen.rtt.framework.util.IPropertyObject;

import static de.fernunihagen.rtt.internal.util.PropertyUtil.getConvertedProperty;

/**
 * Property object comparator class, compares objects assuming a integer
 * property value identified by given key.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class PropertyObjectIntComparator implements
		Comparator<IPropertyObject<? extends Object>>, Serializable {

	private static final long serialVersionUID = 5806726620934922735L;

	@Invar("null != $target")
	private final String _propertyKey;

	/**
	 * Creates an engine detector comparator.
	 * 
	 * @param propertyKey
	 *            Property key used to retrieve compare value
	 */
	@Pre("null != propertyKey")
	public PropertyObjectIntComparator(final String propertyKey) {
		_propertyKey = propertyKey;
	}

	@Pre("null != detector")
	@Post("null != $return")
	private int getAdicity(final IPropertyObject<? extends Object> obj) {
		return getConvertedProperty(obj, _propertyKey, 0);
	}

	@Override
	public int compare(final IPropertyObject<? extends Object> arg0,
			final IPropertyObject<? extends Object> arg1) {
		return getAdicity(arg0) - getAdicity(arg1);
	}
}
